%global srcname reactiveData

Name:           ocaml-reactivedata
Version:        0.2.2
Release:        1%{?dist}
Summary:        Declarative events and signals for OCaml

License:        LGPLv3 with exceptions
URL:            https://github.com/ocsigen/reactiveData
Source0:        %{url}/archive/%{version}/%{srcname}-%{version}.tar.gz
# Do not use deprecated Pervasives.compare
Patch0:         %{name}-pervasives.patch

BuildRequires:  ocaml >= 4.06.1
BuildRequires:  ocaml-findlib
BuildRequires:  ocaml-ocamlbuild
BuildRequires:  ocaml-ocamldoc
BuildRequires:  ocaml-react-devel >= 1.2.1

%description
ReactiveData is an OCaml module for functional reactive programming (FRP)
based on React.  It adds support for incremental changes in data
structures by reasoning on patches instead of absolute values.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name}%{?_isa} = %{version}-%{release}
Requires:       ocaml-react-devel%{?_isa}

%description    devel
The %{name}-devel package contains libraries and signature
files for developing applications that use %{name}.

%prep
%autosetup -n %{srcname}-%{version} -p1

# Build with debuginfo.
sed -i 's,classic-display,& -cflag -g -lflag -g,' pkg/topkg.ml

%build
ocaml pkg/build.ml \
%ifarch %{ocaml_native_compiler}
  native=true \
%else
  native=false \
%endif
%ifarch %{ocaml_natdynlink}
  native-dynlink=true
%else
  native-dynlink=false
%endif
ocamlbuild -use-ocamlfind src/api.docdir/index.html

%install
mkdir -p %{buildroot}%{_libdir}/ocaml/%{srcname}
cp -p opam _build/pkg/META _build/src/*.{a,cma,cmi,cmt,cmti,cmx,cmxa,cmxs,mli} \
  %{buildroot}%{_libdir}/ocaml/%{srcname}

%files
%doc CHANGES README.md
%license LICENSE
%dir %{_libdir}/ocaml/%{srcname}/
%{_libdir}/ocaml/%{srcname}/META
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cma
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmi
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmxs
%endif

%files devel
%doc _build/src/api.docdir/*
%{_libdir}/ocaml/%{srcname}/opam
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{srcname}/%{srcname}*.a
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmx
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmxa
%endif
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmt
%{_libdir}/ocaml/%{srcname}/%{srcname}*.cmti
%{_libdir}/ocaml/%{srcname}/%{srcname}*.mli

%changelog
* Wed Dec  1 2021 Jerry James <loganjerry@gmail.com> - 0.2.2-1
- Initial RPM
